# osh
# Copyright (C) 2005 Jack Orenstein <jao@geophile.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import _pg

import sql

def _sqlpostgres():
    return _SqlPostgres()

class _SqlPostgres(sql._DBType):

    def connect(self, db, host, user, password):
        try:
            return _pg.connect(db, host, -1, None, None, user, password)
        except _pg.Error, e:
            raise Exception('Unable to connect to %s: %s' % (db, str(e)))

    def run_query(self, connection, query):
        try:
            query_execution = connection.query(query)
            if query_execution:
                query_result = query_execution.getresult()
                for query_row in query_result:
                    yield query_row
        except _pg.Error, e:
            raise Exception('Error during execution of query %s: %s' % (query, str(e)))

    def run_update(self, connection, query):
        try:
            return connection.query(query)
        except _pg.Error, e:
            raise Exception('Error during execution of update %s: %s' % (query, str(e)))
        
